# Alternative GNU Make project makefile autogenerated by Premake

VITASDK=/usr/local/vitasdk
CC=${VITASDK}/bin/arm-vita-eabi-gcc
CXX=${VITASDK}/bin/arm-vita-eabi-g++

CFLAGS=-fno-strict-aliasing -fomit-frame-pointer -ffunction-sections -fno-lto -fno-optimize-sibling-calls -Wl,-q,--allow-multiple-definition
CXXFLAGS=$(CFLAGS)
LDFLAGS=$(CFLAGS)

ifndef config
  config=debug_vita
endif

ifndef verbose
  SILENT = @
endif

.PHONY: clean prebuild

SHELLTYPE := posix
ifeq (.exe,$(findstring .exe,$(ComSpec)))
	SHELLTYPE := msdos
endif

# Configurations
# #############################################

RESCOMP = windres
INCLUDES += -I../Game -I${VITASDK}/arm-vita-eabi/include/SDL2 -I../PsyCross/include -I../PsyCross/include/psx
FORCE_INCLUDE +=
ALL_CPPFLAGS += $(CPPFLAGS) -MD -MP $(DEFINES) $(INCLUDES) -D__vita__
ALL_RESFLAGS += $(RESFLAGS) $(DEFINES) $(INCLUDES)
LINKCMD = $(CXX) -o "$@" $(OBJECTS) $(RESOURCES) $(ALL_LDFLAGS) $(LIBS)
define PREBUILDCMDS
endef
define PRELINKCMDS
endef
define POSTBUILDCMDS
endef

ifeq ($(config),debug_vita)
TARGETDIR = ../bin/Debug
TARGET = $(TARGETDIR)/REDRIVER2_dbg
OBJDIR = obj/vita/Debug/REDRIVER2
DEFINES += -D_DEBUG -DDEBUG -DNTSC_VERSION -DBUILD_CONFIGURATION_STRING=\"Debug\" -DDEBUG_OPTIONS -DCOLLISION_DEBUG -DCUTSCENE_RECORDER
ALL_CFLAGS += $(CFLAGS) $(ALL_CPPFLAGS)  -g -O0 -Wno-narrowing -Wno-endif-labels -Wno-write-strings -Wno-format-security -Wno-unused-result -fpermissive
ALL_CXXFLAGS += $(CXXFLAGS) $(ALL_CPPFLAGS)  -g -O0 -std=c++11 -Wno-narrowing -Wno-endif-labels -Wno-write-strings -Wno-format-security -Wno-unused-result -fpermissive
LIBS += ../bin/Debug/libPsyCross.a -ljpeg -lopenal -lSDL2 -ldl -lpthread -lSceGxm_stub_weak -lSceTouch_stub_weak -lSceHid_stub_weak -lSceDisplay_stub_weak -lSceCommonDialog_stub_weak -lSceMotion_stub_weak -lSceCtrl_stub_weak -lSceAudio_stub_weak -lSceAudioIn_stub_weak -llibIMGEGL_stub_weak -lSceIme_stub_weak -llibgpu_es4_ext_stub_weak -llibGLESv2_stub_weak -lScePower_stub_weak -lSceAppUtil_stub_weak -lSceAppMgr_stub_weak
LDDEPS += ../bin/Debug/libPsyCross.a
ALL_LDFLAGS += $(LDFLAGS) -L${VITASDK}/arm-vita-eabi/lib

else ifeq ($(config),release_vita)
TARGETDIR = ../bin/Release
TARGET = $(TARGETDIR)/REDRIVER2
OBJDIR = obj/vita/Release/REDRIVER2
DEFINES += -DNDEBUG -DNTSC_VERSION -DBUILD_CONFIGURATION_STRING=\"Release\" -DDEBUG_OPTIONS
ALL_CFLAGS += $(CFLAGS) $(ALL_CPPFLAGS)  -O3 -Wno-narrowing -Wno-endif-labels -Wno-write-strings -Wno-format-security -Wno-unused-result -fpermissive
ALL_CXXFLAGS += $(CXXFLAGS) $(ALL_CPPFLAGS)  -O3 -std=c++11 -Wno-narrowing -Wno-endif-labels -Wno-write-strings -Wno-format-security -Wno-unused-result -fpermissive
LIBS += ../bin/Release/libPsyCross.a -ljpeg -lopenal -lSDL2 -ldl -lpthread -lSceGxm_stub_weak -lSceTouch_stub_weak -lSceHid_stub_weak -lSceDisplay_stub_weak -lSceCommonDialog_stub_weak -lSceMotion_stub_weak -lSceCtrl_stub_weak -lSceAudio_stub_weak -lSceAudioIn_stub_weak -llibIMGEGL_stub_weak -lSceIme_stub_weak -llibgpu_es4_ext_stub_weak -llibGLESv2_stub_weak -lScePower_stub_weak -lSceAppUtil_stub_weak -lSceAppMgr_stub_weak
LDDEPS += ../bin/Release/libPsyCross.a
ALL_LDFLAGS += $(LDFLAGS) -L${VITASDK}/arm-vita-eabi/lib

else ifeq ($(config),release_dev_vita)
TARGETDIR = ../bin/Release_dev
TARGET = $(TARGETDIR)/REDRIVER2_dev
OBJDIR = obj/vita/Release_dev/REDRIVER2
DEFINES += -DNDEBUG -DNTSC_VERSION -DBUILD_CONFIGURATION_STRING=\"Release_dev\" -DDEBUG_OPTIONS -DCOLLISION_DEBUG -DCUTSCENE_RECORDER
ALL_CFLAGS += $(CFLAGS) $(ALL_CPPFLAGS)  -O3 -Wno-narrowing -Wno-endif-labels -Wno-write-strings -Wno-format-security -Wno-unused-result -fpermissive
ALL_CXXFLAGS += $(CXXFLAGS) $(ALL_CPPFLAGS)  -O3 -std=c++11 -Wno-narrowing -Wno-endif-labels -Wno-write-strings -Wno-format-security -Wno-unused-result -fpermissive
LIBS += ../bin/Release_dev/libPsyCross.a -ljpeg -lopenal -lSDL2 -ldl -lpthread -lSceGxm_stub_weak -lSceTouch_stub_weak -lSceHid_stub_weak -lSceDisplay_stub_weak -lSceCommonDialog_stub_weak -lSceMotion_stub_weak -lSceCtrl_stub_weak -lSceAudio_stub_weak -lSceAudioIn_stub_weak -llibIMGEGL_stub_weak -lSceIme_stub_weak -llibgpu_es4_ext_stub_weak -llibGLESv2_stub_weak -lScePower_stub_weak -lSceAppUtil_stub_weak -lSceAppMgr_stub_weak
LDDEPS += ../bin/Release_dev/libPsyCross.a
ALL_LDFLAGS += $(LDFLAGS) -L${VITASDK}/arm-vita-eabi/lib

endif

# Per File Configurations
# #############################################


# File sets
# #############################################

GENERATED :=
OBJECTS :=

GENERATED += $(OBJDIR)/DebugOverlay.o
GENERATED += $(OBJDIR)/E3stuff.o
GENERATED += $(OBJDIR)/FEmain.o
GENERATED += $(OBJDIR)/ReadAVI.o
GENERATED += $(OBJDIR)/VideoPlayer.o
GENERATED += $(OBJDIR)/ai.o
GENERATED += $(OBJDIR)/asmtest.o
GENERATED += $(OBJDIR)/bcoll3d.o
GENERATED += $(OBJDIR)/bcollide.o
GENERATED += $(OBJDIR)/bomberman.o
GENERATED += $(OBJDIR)/camera.o
GENERATED += $(OBJDIR)/cars.o
GENERATED += $(OBJDIR)/cell.o
GENERATED += $(OBJDIR)/civ_ai.o
GENERATED += $(OBJDIR)/compres.o
GENERATED += $(OBJDIR)/convert.o
GENERATED += $(OBJDIR)/cop_ai.o
GENERATED += $(OBJDIR)/cosmetic.o
GENERATED += $(OBJDIR)/cutrecorder.o
GENERATED += $(OBJDIR)/cutscene.o
GENERATED += $(OBJDIR)/d2mapasm.o
GENERATED += $(OBJDIR)/debris.o
GENERATED += $(OBJDIR)/denting.o
GENERATED += $(OBJDIR)/director.o
GENERATED += $(OBJDIR)/dr2locale.o
GENERATED += $(OBJDIR)/dr2roads.o
GENERATED += $(OBJDIR)/draw.o
GENERATED += $(OBJDIR)/drivinggames.o
GENERATED += $(OBJDIR)/envsound.o
GENERATED += $(OBJDIR)/event.o
GENERATED += $(OBJDIR)/felony.o
GENERATED += $(OBJDIR)/fmvplay.o
GENERATED += $(OBJDIR)/fs.o
GENERATED += $(OBJDIR)/gamesnd.o
GENERATED += $(OBJDIR)/glaunch.o
GENERATED += $(OBJDIR)/handling.o
GENERATED += $(OBJDIR)/ini.o
GENERATED += $(OBJDIR)/job_fx.o
GENERATED += $(OBJDIR)/leadai.o
GENERATED += $(OBJDIR)/loadsave.o
GENERATED += $(OBJDIR)/loadview.o
GENERATED += $(OBJDIR)/main.o
GENERATED += $(OBJDIR)/map.o
GENERATED += $(OBJDIR)/mc_snd.o
GENERATED += $(OBJDIR)/mdraw.o
GENERATED += $(OBJDIR)/mgeneric.o
GENERATED += $(OBJDIR)/mission.o
GENERATED += $(OBJDIR)/models.o
GENERATED += $(OBJDIR)/motion_c.o
GENERATED += $(OBJDIR)/objanim.o
GENERATED += $(OBJDIR)/objcoll.o
GENERATED += $(OBJDIR)/overlay.o
GENERATED += $(OBJDIR)/overmap.o
GENERATED += $(OBJDIR)/pad.o
GENERATED += $(OBJDIR)/pathfind.o
GENERATED += $(OBJDIR)/pause.o
GENERATED += $(OBJDIR)/pedest.o
GENERATED += $(OBJDIR)/players.o
GENERATED += $(OBJDIR)/pres.o
GENERATED += $(OBJDIR)/redriver2_psxpc.o
GENERATED += $(OBJDIR)/replays.o
GENERATED += $(OBJDIR)/riff.o
GENERATED += $(OBJDIR)/rnc_2.o
GENERATED += $(OBJDIR)/rndrasm.o
GENERATED += $(OBJDIR)/roadbits.o
GENERATED += $(OBJDIR)/scores.o
GENERATED += $(OBJDIR)/search.o
GENERATED += $(OBJDIR)/shadow.o
GENERATED += $(OBJDIR)/sky.o
GENERATED += $(OBJDIR)/snd_al_source.o
GENERATED += $(OBJDIR)/snd_wav_cache.o
GENERATED += $(OBJDIR)/snd_wav_source.o
GENERATED += $(OBJDIR)/sound.o
GENERATED += $(OBJDIR)/spool.o
GENERATED += $(OBJDIR)/state.o
GENERATED += $(OBJDIR)/sysclock.o
GENERATED += $(OBJDIR)/system.o
GENERATED += $(OBJDIR)/targa.o
GENERATED += $(OBJDIR)/targets.o
GENERATED += $(OBJDIR)/texture.o
GENERATED += $(OBJDIR)/tile.o
GENERATED += $(OBJDIR)/time.o
GENERATED += $(OBJDIR)/wheelforces.o
GENERATED += $(OBJDIR)/xaplay.o
GENERATED += $(OBJDIR)/xmplay.o
OBJECTS += $(OBJDIR)/DebugOverlay.o
OBJECTS += $(OBJDIR)/E3stuff.o
OBJECTS += $(OBJDIR)/FEmain.o
OBJECTS += $(OBJDIR)/ReadAVI.o
OBJECTS += $(OBJDIR)/VideoPlayer.o
OBJECTS += $(OBJDIR)/ai.o
OBJECTS += $(OBJDIR)/asmtest.o
OBJECTS += $(OBJDIR)/bcoll3d.o
OBJECTS += $(OBJDIR)/bcollide.o
OBJECTS += $(OBJDIR)/bomberman.o
OBJECTS += $(OBJDIR)/camera.o
OBJECTS += $(OBJDIR)/cars.o
OBJECTS += $(OBJDIR)/cell.o
OBJECTS += $(OBJDIR)/civ_ai.o
OBJECTS += $(OBJDIR)/compres.o
OBJECTS += $(OBJDIR)/convert.o
OBJECTS += $(OBJDIR)/cop_ai.o
OBJECTS += $(OBJDIR)/cosmetic.o
OBJECTS += $(OBJDIR)/cutrecorder.o
OBJECTS += $(OBJDIR)/cutscene.o
OBJECTS += $(OBJDIR)/d2mapasm.o
OBJECTS += $(OBJDIR)/debris.o
OBJECTS += $(OBJDIR)/denting.o
OBJECTS += $(OBJDIR)/director.o
OBJECTS += $(OBJDIR)/dr2locale.o
OBJECTS += $(OBJDIR)/dr2roads.o
OBJECTS += $(OBJDIR)/draw.o
OBJECTS += $(OBJDIR)/drivinggames.o
OBJECTS += $(OBJDIR)/envsound.o
OBJECTS += $(OBJDIR)/event.o
OBJECTS += $(OBJDIR)/felony.o
OBJECTS += $(OBJDIR)/fmvplay.o
OBJECTS += $(OBJDIR)/fs.o
OBJECTS += $(OBJDIR)/gamesnd.o
OBJECTS += $(OBJDIR)/glaunch.o
OBJECTS += $(OBJDIR)/handling.o
OBJECTS += $(OBJDIR)/ini.o
OBJECTS += $(OBJDIR)/job_fx.o
OBJECTS += $(OBJDIR)/leadai.o
OBJECTS += $(OBJDIR)/loadsave.o
OBJECTS += $(OBJDIR)/loadview.o
OBJECTS += $(OBJDIR)/main.o
OBJECTS += $(OBJDIR)/map.o
OBJECTS += $(OBJDIR)/mc_snd.o
OBJECTS += $(OBJDIR)/mdraw.o
OBJECTS += $(OBJDIR)/mgeneric.o
OBJECTS += $(OBJDIR)/mission.o
OBJECTS += $(OBJDIR)/models.o
OBJECTS += $(OBJDIR)/motion_c.o
OBJECTS += $(OBJDIR)/objanim.o
OBJECTS += $(OBJDIR)/objcoll.o
OBJECTS += $(OBJDIR)/overlay.o
OBJECTS += $(OBJDIR)/overmap.o
OBJECTS += $(OBJDIR)/pad.o
OBJECTS += $(OBJDIR)/pathfind.o
OBJECTS += $(OBJDIR)/pause.o
OBJECTS += $(OBJDIR)/pedest.o
OBJECTS += $(OBJDIR)/players.o
OBJECTS += $(OBJDIR)/pres.o
OBJECTS += $(OBJDIR)/redriver2_psxpc.o
OBJECTS += $(OBJDIR)/replays.o
OBJECTS += $(OBJDIR)/riff.o
OBJECTS += $(OBJDIR)/rnc_2.o
OBJECTS += $(OBJDIR)/rndrasm.o
OBJECTS += $(OBJDIR)/roadbits.o
OBJECTS += $(OBJDIR)/scores.o
OBJECTS += $(OBJDIR)/search.o
OBJECTS += $(OBJDIR)/shadow.o
OBJECTS += $(OBJDIR)/sky.o
OBJECTS += $(OBJDIR)/snd_al_source.o
OBJECTS += $(OBJDIR)/snd_wav_cache.o
OBJECTS += $(OBJDIR)/snd_wav_source.o
OBJECTS += $(OBJDIR)/sound.o
OBJECTS += $(OBJDIR)/spool.o
OBJECTS += $(OBJDIR)/state.o
OBJECTS += $(OBJDIR)/sysclock.o
OBJECTS += $(OBJDIR)/system.o
OBJECTS += $(OBJDIR)/targa.o
OBJECTS += $(OBJDIR)/targets.o
OBJECTS += $(OBJDIR)/texture.o
OBJECTS += $(OBJDIR)/tile.o
OBJECTS += $(OBJDIR)/time.o
OBJECTS += $(OBJDIR)/wheelforces.o
OBJECTS += $(OBJDIR)/xaplay.o
OBJECTS += $(OBJDIR)/xmplay.o

# Rules
# #############################################

all: $(TARGET)
	@:

$(TARGET): $(GENERATED) $(OBJECTS) $(LDDEPS) | $(TARGETDIR)
	$(PRELINKCMDS)
	@echo Linking REDRIVER2
	$(SILENT) $(LINKCMD)
	$(POSTBUILDCMDS)

$(TARGETDIR):
	@echo Creating $(TARGETDIR)
ifeq (posix,$(SHELLTYPE))
	$(SILENT) mkdir -p $(TARGETDIR)
else
	$(SILENT) mkdir $(subst /,\\,$(TARGETDIR))
endif

$(OBJDIR):
	@echo Creating $(OBJDIR)
ifeq (posix,$(SHELLTYPE))
	$(SILENT) mkdir -p $(OBJDIR)
else
	$(SILENT) mkdir $(subst /,\\,$(OBJDIR))
endif

clean:
	@echo Cleaning REDRIVER2
ifeq (posix,$(SHELLTYPE))
	$(SILENT) rm -f  $(TARGET)
	$(SILENT) rm -rf $(GENERATED)
	$(SILENT) rm -rf $(OBJDIR)
else
	$(SILENT) if exist $(subst /,\\,$(TARGET)) del $(subst /,\\,$(TARGET))
	$(SILENT) if exist $(subst /,\\,$(GENERATED)) del /s /q $(subst /,\\,$(GENERATED))
	$(SILENT) if exist $(subst /,\\,$(OBJDIR)) rmdir /s /q $(subst /,\\,$(OBJDIR))
endif

prebuild: | $(OBJDIR)
	$(PREBUILDCMDS)

ifneq (,$(PCH))
$(OBJECTS): $(GCH) | $(PCH_PLACEHOLDER)
$(GCH): $(PCH) | prebuild
	@echo $(notdir $<)
	$(SILENT) $(CXX) -x c++-header $(ALL_CXXFLAGS) -o "$@" -MF "$(@:%.gch=%.d)" -c "$<"
$(PCH_PLACEHOLDER): $(GCH) | $(OBJDIR)
ifeq (posix,$(SHELLTYPE))
	$(SILENT) touch "$@"
else
	$(SILENT) echo $null >> "$@"
endif
else
$(OBJECTS): | prebuild
endif


# File Rules
# #############################################

$(OBJDIR)/DebugOverlay.o: ../DebugOverlay.cpp
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/asmtest.o: ../Game/ASM/asmtest.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/compres.o: ../Game/ASM/compres.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/d2mapasm.o: ../Game/ASM/d2mapasm.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/rnc_2.o: ../Game/ASM/rnc_2.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/rndrasm.o: ../Game/ASM/rndrasm.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/E3stuff.o: ../Game/C/E3stuff.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/ai.o: ../Game/C/ai.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/bcoll3d.o: ../Game/C/bcoll3d.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/bcollide.o: ../Game/C/bcollide.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/bomberman.o: ../Game/C/bomberman.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/camera.o: ../Game/C/camera.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/cars.o: ../Game/C/cars.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/cell.o: ../Game/C/cell.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/civ_ai.o: ../Game/C/civ_ai.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/convert.o: ../Game/C/convert.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/cop_ai.o: ../Game/C/cop_ai.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/cosmetic.o: ../Game/C/cosmetic.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/cutrecorder.o: ../Game/C/cutrecorder.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/cutscene.o: ../Game/C/cutscene.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/debris.o: ../Game/C/debris.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/denting.o: ../Game/C/denting.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/director.o: ../Game/C/director.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/dr2roads.o: ../Game/C/dr2roads.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/draw.o: ../Game/C/draw.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/drivinggames.o: ../Game/C/drivinggames.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/envsound.o: ../Game/C/envsound.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/event.o: ../Game/C/event.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/felony.o: ../Game/C/felony.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/fmvplay.o: ../Game/C/fmvplay.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/gamesnd.o: ../Game/C/gamesnd.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/glaunch.o: ../Game/C/glaunch.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/handling.o: ../Game/C/handling.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/job_fx.o: ../Game/C/job_fx.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/leadai.o: ../Game/C/leadai.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/loadsave.o: ../Game/C/loadsave.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/loadview.o: ../Game/C/loadview.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/main.o: ../Game/C/main.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/map.o: ../Game/C/map.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/mc_snd.o: ../Game/C/mc_snd.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/mdraw.o: ../Game/C/mdraw.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/mgeneric.o: ../Game/C/mgeneric.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/mission.o: ../Game/C/mission.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/models.o: ../Game/C/models.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/motion_c.o: ../Game/C/motion_c.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/objanim.o: ../Game/C/objanim.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/objcoll.o: ../Game/C/objcoll.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/overlay.o: ../Game/C/overlay.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/overmap.o: ../Game/C/overmap.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/pad.o: ../Game/C/pad.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/pathfind.o: ../Game/C/pathfind.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/pause.o: ../Game/C/pause.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/pedest.o: ../Game/C/pedest.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/players.o: ../Game/C/players.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/pres.o: ../Game/C/pres.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/replays.o: ../Game/C/replays.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/roadbits.o: ../Game/C/roadbits.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/scores.o: ../Game/C/scores.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/search.o: ../Game/C/search.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/shadow.o: ../Game/C/shadow.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/sky.o: ../Game/C/sky.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/sound.o: ../Game/C/sound.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/spool.o: ../Game/C/spool.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/state.o: ../Game/C/state.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/sysclock.o: ../Game/C/sysclock.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/system.o: ../Game/C/system.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/targets.o: ../Game/C/targets.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/texture.o: ../Game/C/texture.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/tile.o: ../Game/C/tile.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/time.o: ../Game/C/time.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/wheelforces.o: ../Game/C/wheelforces.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/xaplay.o: ../Game/C/xaplay.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/xmplay.o: ../Game/C/xmplay.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/FEmain.o: ../Game/Frontend/FEmain.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/dr2locale.o: ../Game/dr2locale.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/redriver2_psxpc.o: ../redriver2_psxpc.cpp
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/snd_al_source.o: ../utils/audio_source/snd_al_source.cpp
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/snd_wav_cache.o: ../utils/audio_source/snd_wav_cache.cpp
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/snd_wav_source.o: ../utils/audio_source/snd_wav_source.cpp
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/fs.o: ../utils/fs.cpp
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/ini.o: ../utils/ini.c
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/riff.o: ../utils/riff.cpp
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/targa.o: ../utils/targa.cpp
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/ReadAVI.o: ../utils/video_source/ReadAVI.cpp
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"
$(OBJDIR)/VideoPlayer.o: ../utils/video_source/VideoPlayer.cpp
	@echo "$(notdir $<)"
	$(SILENT) $(CXX) $(ALL_CXXFLAGS) $(FORCE_INCLUDE) -o "$@" -MF "$(@:%.o=%.d)" -c "$<"

-include $(OBJECTS:%.o=%.d)
ifneq (,$(PCH))
  -include $(PCH_PLACEHOLDER).d
endif
